/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-grasp-stability-msgs-0.0.5-0precise-20150424-1739/srv/Control.srv
 *
 */


#ifndef GRASP_STABILITY_MSGS_MESSAGE_CONTROLRESPONSE_H
#define GRASP_STABILITY_MSGS_MESSAGE_CONTROLRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace grasp_stability_msgs
{
template <class ContainerAllocator>
struct ControlResponse_
{
  typedef ControlResponse_<ContainerAllocator> Type;

  ControlResponse_()
    : result(0)  {
    }
  ControlResponse_(const ContainerAllocator& _alloc)
    : result(0)  {
    }



   typedef int32_t _result_type;
  _result_type result;


    enum { FAILURE = 0 };
     enum { SUCCESS = 1 };
 

  typedef boost::shared_ptr< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ControlResponse_

typedef ::grasp_stability_msgs::ControlResponse_<std::allocator<void> > ControlResponse;

typedef boost::shared_ptr< ::grasp_stability_msgs::ControlResponse > ControlResponsePtr;
typedef boost::shared_ptr< ::grasp_stability_msgs::ControlResponse const> ControlResponseConstPtr;

// constants requiring out of line definition

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace grasp_stability_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'grasp_stability_msgs': ['/tmp/buildd/ros-hydro-grasp-stability-msgs-0.0.5-0precise-20150424-1739/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "0d9206728848e73f5b28b05b46562257";
  }

  static const char* value(const ::grasp_stability_msgs::ControlResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x0d9206728848e73fULL;
  static const uint64_t static_value2 = 0x5b28b05b46562257ULL;
};

template<class ContainerAllocator>
struct DataType< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "grasp_stability_msgs/ControlResponse";
  }

  static const char* value(const ::grasp_stability_msgs::ControlResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "int32 FAILURE=0\n\
int32 SUCCESS=1\n\
int32 result\n\
";
  }

  static const char* value(const ::grasp_stability_msgs::ControlResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.result);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ControlResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::grasp_stability_msgs::ControlResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::grasp_stability_msgs::ControlResponse_<ContainerAllocator>& v)
  {
    s << indent << "result: ";
    Printer<int32_t>::stream(s, indent + "  ", v.result);
  }
};

} // namespace message_operations
} // namespace ros

#endif // GRASP_STABILITY_MSGS_MESSAGE_CONTROLRESPONSE_H
